//+-------------------------------------------
//
//  Class Mysql ver 1.0
//       written by Sungchul KIM.
//            email paranwave@korea.com
//             date 2002. 01. 23
//+-------------------------------------------


#ifndef __CLASS_MYSQL_H__
#define __CLASS_MYSQL_H__

//#define __WIN__
//#define __LINUX__

#ifdef __WIN__
#include <afxsock.h>
#endif

//generic
#include <iostream.h>
#include <limits.h>
#include <string.h>
#include <mysql.h>

class Exception
{
public:
	Exception(char *szString) { strcpy(m_szString, szString); }
	char *Message(void) { return m_szString; }
private:
	char m_szString[CHAR_MAX];
};

//Mysql   ϴ ü

class CMysql
{
public:
	CMysql();
	virtual ~CMysql();
	bool Connect(const char *host=NULL, 
			 	 const char *username=NULL,
				 const char *password=NULL,
				 const char *database=NULL,
				 const unsigned int port=0,
				 const char *unix_socket=NULL,
				 const unsigned int client_flag=0);
	void Disconnect();
	bool IsConnect() { return &conn != NULL; }
	void IsConnect(bool b) { bIsConnect = b; }
   	
	bool Query(const char *szString);
	bool SelectDb(const char *szString);

	//result navigation
	bool IsBOF() { return bIsBof; }
	void IsBOF(bool b) { bIsBof = b; }
	bool IsEOF() { return bIsEof; }
	void IsEOF(bool b) { bIsEof = b; }
	void First();
	void Last();
	void Next();
	void Prev();
	void Move(int n=1);
	
	char * Field(const char *szFieldName);
	char * Field(const my_ulonglong iFieldIndex);

	//operator
	char * operator[](const my_ulonglong iFieldIndex) { return Field(iFieldIndex); }
	//char * operator[](const char *szFieldName) { return Field(szFieldName); }
	ostream& operator<<(ostream& lhs) { return lhs; }

private:
	void		helperConnection();
	void		helperQuery();
	int			helperFieldByName(const char *szString);   //ش ʵ尡 ִ ˻
	void		helperFieldByIndex(const my_ulonglong index);  //ʵε ʵ ū ˻
	void        helperMove(int n);

	MYSQL		conn;
	MYSQL_RES	*pres;
	MYSQL_ROW	row;
	MYSQL_FIELD	*pfield;
//	MYSQL_ROW_OFFSET	RowOffSet;	   //MYSQL_ROWS *
//	MYSQL_FIELD_OFFSET	FieldOffSet;   //unsigned int

	my_ulonglong iRowNum;			   //ڵ 
	unsigned int iFieldNum;			   //ʵ 
	my_ulonglong iCurrentPos;		   // row  offset

	bool bHaveResultQuery;	   // ִ ΰ?
	bool bIsEof;				   //ڵ óΰ?
	bool bIsBof;				   //ڵ ΰ?
	bool bIsConnect;			   //  Ǿ ִ°?
};

#endif

